<?php
/*
Plugin Name: bsuite_geocode
Plugin URI: http://maisonbisson.com/blog/search/bsuite_geocode
Description: It's not the worst geocoding plugin
Version: 0.0.b1 Sep 26
Author: Casey Bisson
Author URI: http://maisonbisson.com/blog/
*/

/*  Copyright 2005  Casey Bisson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



//
// read through an bunch of HTML and return
// the links as a sorted & uniq'd array
//
function bsuite_geocode_geturls($content) {

	// most of this code stolen from pingback() in
	// wp-includes/comment-functions.php
	// the code there notes:
	// original code by Mort (http://mort.mine.nu:8080)
	$post_links = array();

	// Variables
	$ltrs = '\w';
	$gunk = '/#~:.?+=&%@!\-';
//	$punc = '.:?\-'; // this was the original
	$punc = ';,.:?\-'; // added the ";," to accomodate Google Maps
	$any = $ltrs . $gunk . $punc;

	// Parse the post, put external links (if any) in $post_links array
	// This regexp comes straight from phpfreaks.com
	// http://www.phpfreaks.com/quickcode/Extract_All_URLs_on_a_Page/15.php
	preg_match_all("{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $content, $post_links);
	sort($post_links[0]);
	return(array_unique($post_links[0]));
	}
// end function bsuite_geturls



//
// find geocodes in the post
//
function bsuite_getgeocode($content) {

	$post_urls = bsuite_geocode_geturls($content);

	$bsuite_geocode = array();
	foreach($post_urls as $post_url){
		if(strstr($post_url, "http://maps.google")){
			$post_url = str_replace("&amp;","&", $post_url);
			$bsuite_temp = parse_url($post_url);
			parse_str($bsuite_temp[query], $bsuite_temp);
			$bsuite_temp = explode(",", $bsuite_temp[ll]);
			if($bsuite_temp[0])
				$bsuite_geocode[] = array("lat" => $bsuite_temp[0], "lon" => $bsuite_temp[1]);
			}
		if(strstr($post_url, "multimap.com")){
			$post_url = str_replace("&amp;","&", $post_url);
			$bsuite_temp = parse_url($post_url);
			parse_str($bsuite_temp[query], $bsuite_temp);
			if($bsuite_temp[lat])
				$bsuite_geocode[] = array("lat" => $bsuite_temp[lat], "lon" => $bsuite_temp[lon]);
			}
		}

	return($bsuite_geocode);
	}
// end function bsuite_getgeocode



//
// put geocodes in the post output
//
function bsuite_addgeocode($content) {

	$bsuite_geocode = bsuite_getgeocode($content);

	$output = "";
	foreach($bsuite_geocode as $bsuite_geo){
		$output .= "<p style=\"text-align:right;font-size:10px;\">geolocation: <a href=\"http://technorati.com/tags/geo:lat=$bsuite_geo[lat]\" rel=\"tag\">geo:lat=$bsuite_geo[lat]</a>, <a href=\"http://technorati.com/tags/geo:lon=$bsuite_geo[lon]\" rel=\"tag\">geo:lon=$bsuite_geo[lon]</a>, <a href=\"http://technorati.com/tags/geotagged\" rel=\"tag\">geotagged</a>, <a href=\"http://technorati.com/tags/geolocation:$bsuite_geo[lat],$bsuite_geo[lon]\" rel=\"tag\">geolocation:$bsuite_geo[lat],$bsuite_geo[lon]</a>
<a href=\"http://www.geobloggers.com/index.cfm?action=search&cutoff=100&fLat=$bsuite_geo[lat]&fLon=$bsuite_geo[lon]&iStartRecord=1&iMaxRecords=25&iZL=6&sMapMode=hybrid&sSearchType=newest&lstItemType=flickr,note,audio,video,link\">geobloggers</a></p>";
		$output .= "<meta name=\"geo.position\" content=\"$bsuite_geo[lat];$bsuite_geo[lon]\">";
		$output .= "<meta name=\"ICBM\" content=\"$bsuite_geo[lat], $bsuite_geo[lon]\"> \n<meta name=\"DC.title\" content=\"THE NAME OF YOUR SITE\">";
		}
	$output .= "";

	return($content . $output);
	}
// end function bsuite_addgeocode



//
// put geocodes in the meta table for the post
// format is compatible with the Asymptomatic/RedAlt Geo plugin
// http://www.asymptomatic.net/wp-hacks
// http://redalt.com/downloads/
//
function bsuite_geocode_post($id) {

	// get the post content
	$bsuite_temp = wp_get_single_post($id, ARRAY_A);
	$bsuite_temp = add_magic_quotes($bsuite_temp);

	$bsuite_geocode = bsuite_getgeocode($bsuite_temp[post_content]);

	delete_post_meta($id, '_geo_location');

	foreach($bsuite_geocode as $bsuite_geo){
		add_post_meta($id, '_geo_location', $bsuite_geo[lat] . ',' . $bsuite_geo[lon]);
		}

	return(true);
	}
// end function bsuite_addgeocode



//
// register WordPress hooks
//
add_filter('the_content', 'bsuite_addgeocode', 1);
add_action('save_post', 'bsuite_geocode_post');
add_action('edit_post', 'bsuite_geocode_post');
add_action('publish_post', 'bsuite_geocode_post');
// end register WordPress hooks



?>